<template>
    <div class="settigs-app">
        <div class="app-header">
            <div class="top-app">
                <span v-on:click="goTimer" class="profile icon-close"></span>
                <h1 class="title">Settings</h1>
                <span class="settings"></span>
            </div>
        </div>
        <form class="settings-form"  method="POST" action>

            <div class="url-jira">
                <label for="jira-url">JIRA Url:</label>
                <input id="jira-url" v-model="settings.jiraUrl" type="text">
                <span v-bind:class="[serviceStatus? 'status-success': '' ,'icon-bullet']"></span>
            </div>
            <p class="separator">
                <input v-model="settings.saveTimers" type="checkbox" id="save"/>
                <label for="save">Save timer states on program exit</label>
            </p>
            <p class="separator">
                <input v-model="settings.pauseOnBlock" type="checkbox" id="pause"/>
                <label for="pause">Pause timer on session idle</label>
            </p>
            <p class="separator">
                <input v-model="settings.startWithOS" type="checkbox" id="enable"/>
                <label for="enable">Start when system starts</label>
            </p>
            <p class="separator">
                <input v-model="settings.firstSubmitStatus" type="checkbox" id="change"/>
                <label for="change">Change task to progress in first submit</label>
            </p>
            <!--<input type="submit" value="Save">-->
            <p class="version">v 1.0.10</p>
        </form>
    </div>
</template>

<script>
    const {ipcRenderer} = window.require('electron')
    export default {

      name: 'settigs-page',
      data () {
        return {
          settings: {jiraUrl: '', saveTimers: '', pauseOnBlock: '', startWithOS: '', firstSubmitStatus: ''},
          serviceStatus: false
        }
      },
      watch: {
        'settings.jiraUrl': function (val, oldVal) {
          if (val.length > 15) {
              this.saveState()
              ipcRenderer.send('validate-hostname', val)
          }
        },
        'settings.saveTimers': function () {
          this.saveState()
        },
        'settings.pauseOnBlock': function () {
          this.saveState()
        },
        'settings.startWithOS': function () {
          this.saveState()
        },
         'settings.firstSubmitStatus': function () {
          this.saveState()
        }
      },
      methods: {
        goTimer: function () {
          this.saveState()
          this.$router.push('timer')
        },
        saveState: function () {
          ipcRenderer.send('save-settings', this.settings)
        }
      },
      created: function () {
        ipcRenderer.send('init-settings', '')
        ipcRenderer.on('initialize-settings', (event, arg) => {
          this.settings = arg
        })
        ipcRenderer.on('hostname-validation-success', (event, arg) => {
          this.serviceStatus = true
        })
        ipcRenderer.on('hostname-validation-fail', (event, arg) => {
          this.serviceStatus = false
        })
      }
    }
</script>

<style scoped lang="scss">
    @import url('https://fonts.googleapis.com/css?family=Roboto');


    $red-color: #ef5f59;

    $roboto: 'Roboto', sans-serif;

   .status-success{
       color: #3e9935 !important;
   }

    .settigs-app {
        width: 100%;
        height: 100vh;
        background: #FBFBFB;
        color: #888;
        overflow-y: hidden;
    }
    .app-header {
        height: 50px;
        background: $red-color;
        color:#FFF;
        .top-app {
            width: 100%;
            height: 50px;
            line-height: 50px;
            text-align: center;
            box-shadow: 0 2px 5px -1px rgba(80, 79, 79, 0.75);
            position: relative;
            display: flex;
            justify-content: space-between;
            align-items: center;
            h1.title {
                font-family: $roboto;
                font-size: 18px;
                margin: 0;
                font-weight: 500;
            }
            span {
                font-size: 22px;
                color: #FFF;
                width: 45px;
                text-align: center;
                display: inline-block;
                &:hover {
                    color: #FEE;
                    cursor: pointer;
                    transition: all .3s;
                }

            }
        }
    }

    .settings-form{
        width: 95%;
        margin: 25px auto 0;
        .version{
            text-align: center;
        }
        .url-jira{
            text-align:center;
            label{
                font-family: $roboto;
                font-size: 14px;
            }
            input[type="text"]{
                font-family: $roboto;
                height: 25px;
                text-indent: 5px;
                width: 60%;
                font-size: 14px;
                border-radius: 5px;
                border:1px solid rgba(#888,.4%);
                color:#888;
            }
            span{
                color: #cc443d;
            }
        }
        input[type="submit"]{
            width: 60%;
            height: 35px;
            margin: auto;
            display: flex;
            justify-content: center;
            border:none;
            background: darken(#ec4f33,10%) ;
            color:#FFF;
            font-family: $roboto;
            transition: all .4s;
            cursor:pointer;
            &:hover{
                transition: all .4s;
                background:darken(#ec4f33,11%);
            }

        }
        .separator{
            border-bottom: 1px solid rgba(#888,.2%);
            padding: 10px 0 10px 0;
        }
    }

    /*ESTILOS CHECKBOX (NO TOCAR)*/
    [type="checkbox"]:not(:checked),
    [type="checkbox"]:checked {
        position: absolute;
        left: -9999px;
    }
    [type="checkbox"]:not(:checked) + label,
    [type="checkbox"]:checked + label {
        position: relative;
        padding-left: 1.95em;
        cursor: pointer;
        font-family: $roboto;
        font-size: 15px;

    }

    /* checkbox aspect */
    [type="checkbox"]:not(:checked) + label:before,
    [type="checkbox"]:checked + label:before {
        content: '';
        position: absolute;
        left: 0; top: 0;
        width: 1.25em; height: 1.25em;
        border: 2px solid #ccc;
        background: #fff;
        border-radius: 4px;
        box-shadow: inset 0 1px 3px rgba(0,0,0,.1);
    }
    /* checked mark aspect */
    [type="checkbox"]:not(:checked) + label:after,
    [type="checkbox"]:checked + label:after {
        content: '✔';
        position: absolute;
        top: .1em; left: .3em;
        font-size: 1.3em;
        line-height: 0.8;
        color: #ec4f33;
        transition: all .2s;
    }
    /* checked mark aspect changes */
    [type="checkbox"]:not(:checked) + label:after {
        opacity: 0;
        transform: scale(0);
    }
    [type="checkbox"]:checked + label:after {
        opacity: 1;
        transform: scale(1);
    }

</style>
